#include <stdio.h>
#include "usedll.h"

typedef void (* FUNC0)();
typedef void (* FUNC1)(const char*);

int huge enumExpFunc(const char* name, PDLLPROC pExpEntry)
{
	printf("%s\n",name);
	return 1;
}

int main(int argc, char* argv[])
{
	HDLL hDll = LoadLibrary("testdll.exe");
    if (hDll == 0)
    {
		printf("error loding library\n");
		return 1;
	}
	FUNC0 sayHello = (FUNC0) GetProcAddress(hDll,"sayHello");
    if (sayHello == 0)
		printf("sayHello not found\n");
	else
	   sayHello();
	FUNC1 sayHello2 = (FUNC1) GetProcAddress(hDll,"sayHello(const char*)");
    if (sayHello2 == 0)
		printf("sayHello(const char*) not found\n");
	else
	   sayHello2("DllApp");
    printf("\nNow enumerate exports:\n");
    EnumExports(hDll,&enumExpFunc);
    if (FreeLibrary(hDll) < 0)
    {
       printf("Unloading library failed!\n");
       return 2;
    }
    return 0;
}